; script for books reader program "Balabolka"
;by Leonid Zhilin 2017
; supported syntax Jaws11 and later 

Include "hjconst.jsh"
include "common.jsm"
include "msaaconst.jsh"

import "default.jsd"

Const
MainClassName="Form",
MemoClassName = "TPlusMemo",
PanelClassName = "TPanel",
TsPanelClassName="TsPanel",
CheckListBoxClassName ="TsCheckListBox",
TabFolderClass = "TsTabSheet",
OptionClassName = "TSetForm",
TrackbarClass = "TsTrackBar",
VoiceValue = "||",
VoiceValues = "Right=|Left=|Up=|Down=|PageUp=|PageDown="

Globals
collection cgeneral,
int isSpeak

Messages
@msg_Pause

@@
@msg_Help
  :

F10/F11 -       ,
*2 -  .
Control+F9 -    .
Alt+F10 -            .

F5 - .
F6 -    .
F7 -  .

      ESCape.
@@
@msg_IsNotRead
 ,   AltTab.
@@
EndMessages

Int Function GetOperableHandles (handle hWnd)
var
string sClass=GetWindowClass (hWnd)

if sClass == MemoClassName
	if !cGeneral.memo then cGeneral.memo=hWnd endif
elif sClass ==  PanelClassName
	if !cGeneral.voice then cGeneral.voice=GetFirstChild (hWnd)
cGeneral.bkList=GetNextWindow (cGeneral.voice)
	endif
elif sClass == CheckListBoxClassName && GetWindowClass (GetParent(hWnd)) == TsPanelClassName
	if !cGeneral.dic then cGeneral.dic=hWnd endif
endif
Return True
EndFunction

Void Function AutoStartEvent ()
if !CollectionItemExists (cGeneral, "scr")  then cGeneral=new collection endif
if isSpeak then SpeechOff () endif
AutoStartEvent()
EndFunction

Void Function AutoFinishEvent ()
if isSpeak then SpeechOn () endif
AutoFinishEvent()
EndFunction

Int Function HandleCustomAppWindows (handle hAppWin)
CollectionRemoveAll (cGeneral)
if StringContains (GetWindowClass(hAppWin),MainClassName) then EnumerateChildWindows (hAppWin, "GetOperableHandles") endif
Return False
EndFunction

Int Function HandleCustomWindows (handle hWnd)
var
string sname, string sClass=GetWindowClass (hWnd), string sRealClass=GetWindowClass(GetrealWindow(hWnd))

if StringContains (sRealClass,MainClassName)
	if sClass == TrackBarClass then sname=StringRight(GetWindowName(cGeneral.voice), 1)
		if sName==4
			if hWnd==GetPriorWindow(GetLastWindow (hWnd)) then sname=StringSegment(VoiceValue, cScListSeparator, 1)
			else sname=StringSegment(VoiceValue, cScListSeparator, 2)
			endif
		elif sname == 5 then
			if hWnd==GetFirstWindow (hWnd) then sname=StringSegment(VoiceValue, cScListSeparator, 2)
			elif hWnd==GetLastWindow (hWnd) then sname=StringSegment(VoiceValue, cScListSeparator, 1)
			else sname=StringSegment(VoiceValue, cScListSeparator, 3)
			endif
	endif
		IndicateControlType (GetWindowSubtypeCode (hWnd, False), sname, GetObjectValue (True, False))
	elif sClass==CheckListBoxClassName  then 
		IndicateControlType (GetWindowSubtypeCode (hWnd, False), sname, GetItemState ())
	else Return False
	endif
Return True
endif
Return False
EndFunction

void function FocusChangedEventEx (handle hwndFocus, int nObject, int nChild, handle hwndPrevFocus, int nPrevObject, int nPrevChild, int nChangeDepth)
var
String sClass= GetWindowClass (hWndFocus)

if StringContains(sClass,MainClassname) && !MenusActive ()
	SetFocus(cGeneral.memo)
	Return
endif
  FocusChangedEventEx (hwndFocus, nObject, nChild, hwndPrevFocus, nPrevObject, nPrevChild, nChangeDepth)
EndFunction

Script hotkeyhelp ()
var
string msg
If UserBufferIsActive ()
 UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, msg_Help, msg_Help)
EndScript

Function SpeakToggle (int mode)
var
handle hFocus=GetFocus(),
int x,
string sClass=GetWindowClass (hFocus),
string sRealClass=GetWindowClass(GetRealWindow(hFocus))
if StringContains(sRealClass,MainClassName)
	if sClass == MemoClassName 
		if mode==1 SpeechOff ()
			PlaySound (FindJAWSSoundFile ("click3.wav", False))
		elif mode==2 then 
			if IsSpeechOff () then SpeechOn ()
			else SpeechOff ()
			endif
			PlaySound (FindJAWSSoundFile ("click4.wav", False))
		elif mode==3 then SpeechOn ()
			PlaySound (FindJAWSSoundFile ("click5.wav", False))
		endif
		isSpeak=IsSpeechOff ()
	endif
endif
TypeCurrentScriptKey ()
EndFunction

Script SpeakStarting ()
SpeakToggle (1)
EndScript

Script SpeakPause ()
SpeakToggle (2)
EndScript

Script SpeakStop ()
SpeakToggle (3)
EndScript

String Function GetItemState (optional int nspeak)
var string flag
Pause()
SaveCursor ()
RouteInvisibleToPc ()
InvisibleCursor ()
PriorChunk ()
flag=GetChunk ()
RestoreCursor ()
if nspeak then Say(flag, OT_Item_State) endif
Return flag
EndFunction

Void Function ActiveItemChangedEvent (handle curHwnd, int curObjectId, int curChildId, handle prevHwnd, int prevObjectId, int prevChildId)
var
  String sClass=GetWindowClass(curHwnd)
if StringContains (GetWindowClass(GetRealWindow(curHwnd)),MainClassName)
	if sClass==CheckListBoxClassName 
		GetItemState (True)
	endif
endif
ActiveItemChangedEvent (curHwnd, curObjectId, curChildId, prevHwnd, prevObjectId, prevChildId)
EndFunction

Script Space ()
var
handle hWnd=GetFocus()
TypeCurrentScriptKey ()
if StringContains (GetWindowClass(GetRealWindow(hWnd)),MainClassName)
	if GetWindowClass(hWnd) == CheckListBoxClassName 
		GetItemState (True)
	endif
endif
EndScript

Void Function ActivatePane (handle hPane)
var
handle hWnd=GetFocus(),
int samescript=IsSameScript ()
if  IsWindowVisible (hPane)
if samescript then   TypeCurrentScriptKey ()
elif hWnd!=hPane then SetFocus(hPane)
	else SayWindowTypeAndText (hWnd) endif
else TypeCurrentScriptKey ()
	Pause()
	SetFocus(hPane)
endif
EndFunction

Script ActivateVoicePane ()
ActivatePane(cGeneral.voice)
EndScript

Script ActivateDicPane ()
ActivatePane(cGeneral.dic)
EndScript

Script GotoToDocument ()
var
handle hWnd=GetFocus()
if StringContains (GetWindowClass(GetRealWindow(hWnd)),MainClassName)
	if GetWindowClass (hWnd) != MemoClassName then SetFocus(cGeneral.memo)
		Return
	endif
endif
TypeCurrentScriptKey ()

EndScript

Function ChangeVoiceValues (int page)
var
string sDirect=StringChopRight(StringSegment(GetCurrentScriptKeyName (), cscKeyNameComponentSeparator, -1), page)
sDirect=StringSegment(VoiceValues,cScListSeparator, StringSegmentIndex (VoiceValues, cScListSeparator, sDirect, False))
sDirect=StringSegment(SDirect, "=", 2)
Say (sDirect, OT_Message)
Delay (3)
TypeCurrentScriptKey ()
EndFunction

Script ChangeCustomVolume ()
ChangeVoiceValues (0)
EndScript

Script ChangeCustomRate ()
ChangeVoiceValues (5)
EndScript

Script ChangeCustomSpeed ()
ChangeVoiceValues (5)
EndScript

Script NextDocumentWindow ()
PerformScript NextDocumentWindow()
Pause()
var handle hPage=GetFirstWindow (GetParent(cGeneral.memo))
Say (GetWindowName (hPage), OT_Message)
EndScript

Script PreviousDocumentWindow ()
PerformScript PreviousDocumentWindow()
Pause()
var handle hPage=GetFirstWindow (GetParent(cGeneral.memo))
Say (GetWindowName (hPage), OT_Message)
EndScript

Script SelectDocument ()
var handle hWnd=GetFocus()
if StringContains (GetWindowClass(GetrealWindow(hWnd)),MainClassname) then SetFocus(cGeneral.bkList)
else TypeCurrentScriptKey ()
endif
EndScript

Script SayDefaultButton ()
var
handle hWnd=GetRealWindow(GetFocus())
if GetWindowClass(hWnd) == OptionClassName then Say ("Ok", OT_Message)
else PerformScript SayDefaultButton()
endif
EndScript

void function SayLineUnit(int unitMovement, optional int bMoved)
; caret read delay by line bottom window 
var
	handle hWnd=GetFocus()
if StringContains (GetWindowClass(GetRealWindow(hWnd)),MainClassName)
	if  GetWindowClass (hWnd) == MemoClassName
		if GetLineBottom() >= GetWindowBottom (cGeneral.memo) then Delay(3) endif
	endif
endif
SayLineUnit(unitMovement, bMoved)
EndFunction

